/** -------------------------------------------------------------------------
Copyright (c) 2012 Chuck Broadwell W5UXH

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

**/

const unsigned char ascii_to_morse[]= {

  0x00,    //    0b00000000    000    NUL    
  0x00,    //    0b00000000    001    SOH    
  0x00,    //    0b00000000    002    STX    
  0x00,    //    0b00000000    003    ETX    
  0x00,    //    0b00000000    004    EOT    
  0x00,    //    0b00000000    005    ENQ    
  0x00,    //    0b00000000    006    ACK    
  0x00,    //    0b00000000    007    BEL    
  0x00,    //    0b00000000    008    BS     
  0x58,    //    0b01011000    009    HT     AA
  0x00,    //    0b00000000    00A    LF    
  0x00,    //    0b00000000    00B    VT    
  0x00,    //    0b00000000    00C    FF    
  0x8C,    //    0b10001100    00D    CR     BT
  0x00,    //    0b00000000    00E    SO    
  0x00,    //    0b00000000    00F    SI    
  0x00,    //    0b00000000    010    DLE    
  0x00,    //    0b00000000    011    DC1    
  0x00,    //    0b00000000    012    DC2    
  0x00,    //    0b00000000    013    DC3    
  0x00,    //    0b00000000    014    DC4    
  0x00,    //    0b00000000    015    NAK    
  0x00,    //    0b00000000    016    SYN    
  0x00,    //    0b00000000    017    ETB    
  0x00,    //    0b00000000    018    CAN    
  0x00,    //    0b00000000    019    EM    
  0x00,    //    0b00000000    01A    SUB    
  0x00,    //    0b00000000    01B    ESC    
  0x00,    //    0b00000000    01C    FS    
  0x00,    //    0b00000000    01D    GS    
  0x00,    //    0b00000000    01E    RS    
  0x00,    //    0b00000000    01F    US    
  0x00,    //    0b00000000    020    SP    
  0xE8,    //    0b11101000    021    !    
  0x4A,    //    0b01001010    022    "    
  0x00,    //    0b00000000    023    #    
  0x13,    //    0b00010011    024    $    
  0x00,    //    0b00000000    025    %    
  0x13,    //    0b00010011    026    &    
  0x7A,    //    0b01111010    027    '    
  0xB4,    //    0b10110100    028    (    
  0xB6,    //    0b10110110    029    )    
  0x7A,    //    0b01111010    02A    *    
  0x54,    //    0b01010100    02B    +    
  0xCE,    //    0b11001110    02C ,    
  0x86,    //    0b10000110    02D    -    
  0x56,    //    0b01010110    02E    .    
  0x94,    //    0b10010100    02F    /    
  0xFC,    //    0b11111100    030    0    
  0x7C,    //    0b01111100    031    1    
  0x3C,    //    0b00111100    032    2    
  0x1C,    //    0b00011100    033    3    
  0x0C,    //    0b00001100    034    4    
  0x04,    //    0b00000100    035    5    
  0x84,    //    0b10000100    036    6    
  0xC4,    //    0b11000100    037    7    
  0xE4,    //    0b11100100    038    8    
  0xF4,    //    0b11110100    039    9    
  0xE2,    //    0b11100010    03A    :    
  0xAA,    //    0b10101010    03B    ;    
  0x54,    //    0b01010100    03C    <  AR    
  0x8C,    //    0b10001100    03D    =    
  0x16,    //    0b00010110    03E    >  SK
  0x32,    //    0b00110010    03F    ?    
  0x6A,    //    0b01101010    040    @    
  0x60,    //    0b01100000    041    A    
  0x88,    //    0b10001000    042    B    
  0xA8,    //    0b10101000    043    C    
  0x90,    //    0b10010000    044    D    
  0x40,    //    0b01000000    045    E    
  0x28,    //    0b00101000    046    F    
  0xD0,    //    0b11010000    047    G    
  0x08,    //    0b00001000    048    H    
  0x20,    //    0b00100000    049    I    
  0x78,    //    0b01111000    04A    J    
  0xB0,    //    0b10110000    04B    K    
  0x48,    //    0b01001000    04C    L    
  0xE0,    //    0b11100000    04D    M    
  0xA0,    //    0b10100000    04E    N    
  0xF0,    //    0b11110000    04F    O    
  0x68,    //    0b01101000    050    P    
  0xD8,    //    0b11011000    051    Q    
  0x50,    //    0b01010000    052    R    
  0x10,    //    0b00010000    053    S    
  0xC0,    //    0b11000000    054    T    
  0x30,    //    0b00110000    055    U    
  0x18,    //    0b00011000    056    V    
  0x70,    //    0b01110000    057    W    
  0x98,    //    0b10011000    058    X    
  0xB8,    //    0b10111000    059    Y    
  0xC8,    //    0b11001000    05A    Z    
  0xB4,    //    0b10110100    05B    [    
  0x94,    //    0b10010100    05C    '\'    
  0xB6,    //    0b10110110    05D    ]    
  0x36,    //    0b00110110    05E    ^    
  0x36,    //    0b00110110    05F    _    
  0x00,    //    0b00000000    060    `    
  0x60,    //    0b01100000    061    a    
  0x88,    //    0b10001000    062    b    
  0xA8,    //    0b10101000    063    c    
  0x90,    //    0b10010000    064    d    
  0x40,    //    0b01000000    065    e    
  0x28,    //    0b00101000    066    f    
  0xD0,    //    0b11010000    067    g    
  0x08,    //    0b00001000    068    h    
  0x20,    //    0b00100000    069    i    
  0x78,    //    0b01111000    06A    j    
  0xB0,    //    0b10110000    06B    k    
  0x48,    //    0b01001000    06C    l    
  0xE0,    //    0b11100000    06D    m    
  0xA0,    //    0b10100000    06E    n    
  0xF0,    //    0b11110000    06F    o    
  0x68,    //    0b01101000    070    p    
  0xD8,    //    0b11011000    071    q    
  0x50,    //    0b01010000    072    r    
  0x10,    //    0b00010000    073    s    
  0xC0,    //    0b11000000    074    t    
  0x30,    //    0b00110000    075    u    
  0x18,    //    0b00011000    076    v    
  0x70,    //    0b01110000    077    w    
  0x98,    //    0b10011000    078    x    
  0xB8,    //    0b10111000    079    y    
  0xC8,    //    0b11001000    07A    z    
  0x00,    //    0b00000000    07B    {    
  0x00,    //    0b00000000    07C    |    
  0x00,    //    0b00000000    07D    }    
  0x00,    //    0b00000000    07E    ~    
  0x00,    //    0b00000000    07F    DEL    
  0x00, //    0b00000000        080  CAPS LOCK  
  0x44, //    0b01000100        081     F1  AS
  0x14, //    0b00010100        082     F2  VE
  0x54, //    0b01010100        083     F3  AR
  0x16, //    0b00010110        084     F4  SK
  0x00, //    0b00000000        085
  0x00, //    0b00000000        086
  0x00, //    0b00000000        087
  0x00, //    0b00000000        088
  0x00, //    0b00000000        089
  0x00, //    0b00000000        08A
  0x00, //    0b00000000        08B
  0x00, //    0b00000000        08C
  0x00, //    0b00000000        08D
  0x00, //    0b00000000        08E
  0x00  //    0b00000000        08F


};



/** -------------------------------------------------------------------------
@verbatim
Translate the ASCII code to "morse".  The encoding is the same as what we have
used in the past, taken from the W4UX Touchcoder hardware design, except the
byte is reversed so the MS bit is the first element and the byte code is
shifted LEFT for each element.  The final "1" indicates end of character.

This table was copied from the KK7S (Chadd  Knowlton) Arduino code to save
the typing.

@endverbatim

@param [in] ascii  The raw scan code byte sent from the PS-2 keys.
**/


unsigned char asciiToMorseLookup (unsigned char ascii)
{
  return (ascii_to_morse[ascii]);
}
