#include "w5uxhMbedKeyer.h"

const unsigned char morse_to_ascii[]= {

' ' ,    //    0x00    
' ' ,    //    0x01    
' ' ,    //    0x02    
' ' ,    //    0x03    
'5' ,    //    0x04  0b00001100    
' ' ,    //    0x05    
' ' ,    //    0x06    
' ' ,    //    0x07    
'H' ,    //    0x08  0b00001000
' ' ,    //    0x09     
' ' ,    //    0x0A    
' ' ,    //    0x0B    
'4' ,    //    0x0C  0b00001100    
' ' ,    //    0x0D     
' ' ,    //    0x0E    
' ' ,    //    0x0F    
'S' ,    //    0x10  0b00010000
' ' ,    //    0x11    
' ' ,    //    0x12    
' ' ,    //    0x13    
0x82,    //    0x14  0b00010100  VE
' ' ,    //    0x15    
0x84,    //    0x16  0b00010110  SK    
' ' ,    //    0x17    
'V' ,    //    0x18  0b00011000
' ' ,    //    0x19    
' ' ,    //    0x1A    
' ' ,    //    0x1B    
'3' ,    //    0x1C  0b00011100
' ' ,    //    0x1D    
' ' ,    //    0x1E    
' ' ,    //    0x1F    
'I' ,    //    0x20  0b00100000    
' ' ,    //    0x21    
' ' ,    //    0x22    
' ' ,    //    0x23    
' ' ,    //    0x24    
' ' ,    //    0x25    
' ' ,    //    0x26    
' ' ,    //    0x27    
'F' ,    //    0x28  0b00101000
' ' ,    //    0x29    
' ' ,    //    0x2A    
' ' ,    //    0x2B    
' ' ,    //    0x2C
' ' ,    //    0x2D    
' ' ,    //    0x2E    
' ' ,    //    0x2F    
'U' ,    //    0x30  0b00110000
' ' ,    //    0x31    
'?' ,    //    0x32  0b00110010
' ' ,    //    0x33    
' ' ,    //    0x34    
' ' ,    //    0x35    
' ' ,    //    0x36    
' ' ,    //    0x37    
' ' ,    //    0x38    
' ' ,    //    0x39    
' ' ,    //    0x3A    
' ' ,    //    0x3B    
'2' ,    //    0x3C  0b00111100
' ' ,    //    0x3D    
' ' ,    //    0x3E
' ' ,    //    0x3F    
'E' ,    //    0x40  0b01000000
' ' ,    //    0x41    
' ' ,    //    0x42    
' ' ,    //    0x43    
0x81,    //    0x44  0b01000100
' ' ,    //    0x45    
' ' ,    //    0x46    
' ' ,    //    0x47    
'L' ,    //    0x48  0b01001000
' ' ,    //    0x49    
'"' ,    //    0x4A  0b01001010    
' ' ,    //    0x4B    
' ' ,    //    0x4C    
' ' ,    //    0x4D    
' ' ,    //    0x4E    
' ' ,    //    0x4F    
'R' ,    //    0x50  0b01010000    
' ' ,    //    0x51    
' ' ,    //    0x52    
' ' ,    //    0x53    
0x83,    //    0x54  0b01010100  AR
' ' ,    //    0x55    
'.' ,    //    0x56  0b01010110    
' ' ,    //    0x57    
0x09,    //    0x58  0b01011000  AA
' ' ,    //    0x59    
' ' ,    //    0x5A    
' ' ,    //    0x5B    
' ' ,    //    0x5C    
' ' ,    //    0x5D    
' ' ,    //    0x5E    
' ' ,    //    0x5F    
'A' ,    //    0x60  0b01100000
' ' ,    //    0x61    
' ' ,    //    0x62    
' ' ,    //    0x63    
' ' ,    //    0x64    
' ' ,    //    0x65    
' ' ,    //    0x66    
' ' ,    //    0x67    
'P' ,    //    0x68  0b01101000
' ' ,    //    0x69    
' ' ,    //    0x6A    
' ' ,    //    0x6B    
' ' ,    //    0x6C    
' ' ,    //    0x6D    
' ' ,    //    0x6E    
' ' ,    //    0x6F    
'W' ,    //    0x70  0b01110000
' ' ,    //    0x71    
' ' ,    //    0x72    
' ' ,    //    0x73    
' ' ,    //    0x74    
' ' ,    //    0x75    
' ' ,    //    0x76    
' ' ,    //    0x77    
'J' ,    //    0x78  0b01111000    
' ' ,    //    0x79    
'\'' ,    //    0x7A  0b01111010 Apostrophy  How put it between single quotes?    I think the backslash does it.
' ' ,    //    0x7B    
'1' ,    //    0x7C  0b01111100    
' ' ,    //    0x7D    
' ' ,    //    0x7E    
' ' ,    //    0x7F    
' ' ,   //      0x80  
' ' ,   //      0x81
' ' ,   //      0x82
' ' ,   //      0x83
'6' ,   //      0x84  0b10000100
' ' ,   //      0x85
' ' ,   //      0x86
' ' ,   //      0x87
'B' ,   //      0x88  0b10001000
' ' ,   //      0x89
' ' ,   //      0x8A
' ' ,   //      0x8B
0x0D,   //      0x8C  0b10001100
' ' ,   //      0x8D
' ' ,   //      0x8E
' ' ,   //      0x8F
'D' ,   //      0x90  0b10010000
' ' ,   //      0x91
' ' ,   //      0x92
' ' ,   //      0x93
'/' ,   //      0x94  0b10010100  forward slash
' ' ,   //      0x95
' ' ,   //      0x96
' ' ,   //      0x97
'X' ,   //      0x98  0b10011000
' ' ,   //      0x99
' ' ,   //      0x9A
' ' ,   //      0x9B
' ' ,   //      0x9C
' ' ,   //      0x9D
' ' ,   //      0x9E
' ' ,   //      0x9F
'N' ,   //      0xA0  0b10100000
' ' ,   //      0xA1
' ' ,   //      0xA2
' ' ,   //      0xA3
' ' ,   //      0xA4
' ' ,   //      0xA5
' ' ,   //      0xA6
' ' ,   //      0xA7
'C' ,   //      0xA8  0b10101000
' ' ,   //      0xA9
' ' ,   //      0xAA
' ' ,   //      0xAB
' ' ,   //      0xAC
' ' ,   //      0xAD
' ' ,   //      0xAE
' ' ,   //      0xAF
'K' ,   //      0xB0  0b10110000
' ' ,   //      0xB1
' ' ,   //      0xB2
' ' ,   //      0xB3
' ' ,   //      0xB4
' ' ,   //      0xB5
' ' ,   //      0xB6
' ' ,   //      0xB7
'Y' ,   //      0xB8  0b10111000
' ' ,   //      0xB9
' ' ,   //      0xBA
' ' ,   //      0xBB
' ' ,   //      0xBC
' ' ,   //      0xBD
' ' ,   //      0xBE
' ' ,   //      0xBF
'T' ,   //      0xC0  0b11000000
' ' ,   //      0xC1
' ' ,   //      0xC2
' ' ,   //      0xC3
'7' ,   //      0xC4  0b11000100
' ' ,   //      0xC5
' ' ,   //      0xC6
' ' ,   //      0xC7
'Z' ,   //      0xC8  0b11001000
' ' ,   //      0xC9
' ' ,   //      0xCA
' ' ,   //      0xCB
' ' ,   //      0xCC
' ' ,   //      0xCD
',' ,   //      0xCE  0b11001110
' ' ,   //      0xCF
'G' ,   //      0xD0  0b11010000
' ' ,   //      0xD1
' ' ,   //      0xD2
' ' ,   //      0xD3
' ' ,   //      0xD4
' ' ,   //      0xD5
' ' ,   //      0xD6
' ' ,   //      0xD7
'Q' ,   //      0xD8  0b11011000
' ' ,   //      0xD9
' ' ,   //      0xDA
' ' ,   //      0xDB
' ' ,   //      0xDC
' ' ,   //      0xDD
' ' ,   //      0xDE
' ' ,   //      0xDF
'M' ,   //      0xE0  0b11100000
' ' ,   //      0xE1
' ' ,   //      0xE2
' ' ,   //      0xE3
 '8',   //      0xE4  0b11100100
' ' ,   //      0xE5
' ' ,   //      0xE6
' ' ,   //      0xE7
' ' ,   //      0xE8
' ' ,   //      0xE9
' ' ,   //      0xEA
' ' ,   //      0xEB
' ' ,   //      0xEC
' ' ,   //      0xED
' ' ,   //      0xEE
' ' ,   //      0xEF
'O' ,   //      0xF0  0b11110000
' ' ,   //      0xF1
' ' ,   //      0xF2
' ' ,   //      0xF3
'9' ,   //      0xF4  0b11110100
' ' ,   //      0xF5
' ' ,   //      0xF6
' ' ,   //      0xF7
'C' ,   //      0xF8
' ' ,   //      0xF9
' ' ,   //      0xFA
' ' ,   //      0xFB
'0' ,   //      0xFC  0b11111100
' ' ,   //      0xFD
' ' ,   //      0xFE
' '     //      0xFF
};



/** -------------------------------------------------------------------------
@verbatim
Translate the CW bit pattern code to ASCII for use in detecting the ID.

The address into this table is the CW bit pattern, where the MS bit is the
first element.  Subsequent elements are in lower bit positions, with the
"terminating" logic 1 at the end.  All bits to the right of the terminating
logic 1 are zeros.

For example, in the ASCII to MORSE table, the lookup for ASCII numeral "4" is
shown here:

0b00001100,    //    034    4

where the bit pattern is 0b00001100  for dit dit dit dit dah (terminator).
This is hex value 0x0C.  Thus when we gather this bit pattern in the byte that
represents the number 4 having been sent by the paddle, we use this value as the
lookup index into the CW to ASCII table.  The entry in this table at offset 0x0C
thus appears as follows:

'4' ,    //    0x0C    


@endverbatim

@param [in] morse  The CW bit pattern that can be found in the ASCII to morse table.
**/


unsigned char morseToAsciiLookup (unsigned char morse)
{
  return (morse_to_ascii[morse]);
}
